1   REM             BINOMIAL DISTRIBUTION (one-tailed)
2   REM             Written by Tracy L. Gustafson, M.D.
3   REM            Round Rock, Texas. Version 2.1, 1982
5  DEF SEG=&H40
8  A=PEEK(&H17): IF NOT(A AND &H20) THEN POKE &H17,(A AND (NOT &H20)) OR &H20
10  DEF SEG: SCREEN 0,0: WIDTH 80: COLOR 7,0,1: KEY OFF: CLEAR: DEFINT A-C,N,T,Z
15  CLS: PRINT TAB(19);"KEY";STRING$(35,205);"CLOSE"
20  PRINT TAB(19);"OPEN BINOMIAL PROBABILITY DISTRIBUTION OPEN"
25  PRINT TAB(19);"SCREEN";STRING$(35,205);"LOAD": PRINT
30  PRINT TAB(8);"The binomial distribution provides a one-tailed exact test":PRINT "applicable when a dichotomous variable has an equal probability of occurring":  PRINT TAB(27);"in each of N trials.": PRINT
40  PRINT TAB(16);:INPUT "Enter the number of trials (integer) :   ",NT: PRINT
50  PRINT TAB(11);:INPUT "Enter probability of success on each trial:    ",PS
60  IF ABS(PS-0.5)>0.5 THEN BEEP: PRINT TAB(7); "(NOTE: Probability should be fraction between 0 and 1)": GOTO 50
70  PRINT: PRINT TAB(15);:INPUT "Enter the number of successes observed:   ",NO
80  COLOR 23: PRINT: PRINT: AP=CSRLIN: PRINT TAB(25);"CALCULATING PROBABILITY"
100  AF=0: CO=NO: IF NO>INT(PS*NT) THEN AF=1: PS=1-PS: CO=NT-NO
110  QS=1-PS: S=0: F=1: P=EXP(NT*LOG(QS)): LP=LOG(PS): LQ=LOG(QS)
120  FOR T=1 TO CO: FT=T: FZ=NT-FT: S=FT*LP+FZ*LQ
130  IF F>1E+35 OR S<-80 THEN F=LOG(F): GOTO 150
140  F=F*(FZ+1)/FT: P=P+F*EXP(S): NEXT T: GOTO 180
150  FOR Z=T TO CO: FT=Z: FZ=(NT-FT): S=FT*LP+FZ*LQ: F=F+LOG((FZ+1)/FT)
160  IF F+S>-86 THEN P=P+EXP(F+S)
170  NEXT Z
180  FOR Z=4 TO 1 STEP -1: PLAY "MB ML O=Z; L32 B-GE-": NEXT: PLAY "L6 O1 E-"
190  LOCATE AP,1: COLOR 0,7: PRINT TAB(8);"The probability of observing ";NO;" or ";
200  IF AF=1 THEN PRINT "more cases = "; ELSE PRINT "fewer cases = ";
220  IF P<1E-08 THEN PRINT "< 10 (-8)"; ELSE IF P>0.95 THEN PRINT "> .95"; ELSE PRINT P;
240  PRINT TAB(79): COLOR 7,0,1: PRINT: PRINT: PRINT
242  IF NT*PS<10 OR NT*QS<10 OR P>0.05 THEN 250 ELSE P$=".#####"
244  PRINT TAB(15);"The observed proportion of successes is  ";: PRINT USING P$;NO/NT
246  PRINT TAB(10);"Confidence limits can be calculated as:  ";: PRINT USING P$;NO/NT;: PRINT " +/- Z*";: PRINT USING P$;SQR(PS*QS/NT)
250  PRINT: PRINT: PRINT TAB(6);: INPUT "Do you want to perform another binomial calculation? (Y or N)   ",A$
260  IF A$="y" OR A$="Y" THEN 15
270  END
