1   REM         SIGNED RANK, RANK SUM AND RANK CORRELATION TESTS
2  REM             Written by Tracy L. Gustafson, M.D.
3  REM            Round Rock, Texas. Version 2.0, 1983
5  DEF SEG=&H40
6  A=PEEK(&H17): IF NOT(A AND &H20) THEN POKE &H17,(A AND (NOT &H20)) OR &H20
10  DEF SEG: KEY OFF: SCREEN 0,0: WIDTH 80: COLOR 7,0,1
15  CLEAR ,,1024: DEFINT A-C,N,T,Z: DEFSTR D
20  CLS: PRINT TAB(19);"KEY";STRING$(35,205);"CLOSE"
22  PRINT TAB(19);"OPEN RANK TESTS (Non-parametric tests) OPEN"
25  PRINT TAB(19);"SCREEN";STRING$(35,205);"LOAD"
30  PRINT: PRINT: AP=CSRLIN: PRINT TAB(10);: ON ERROR GOTO 1110
40  PRINT "What is the name of the DATAFILE you wish to analyze?"
41  PRINT TAB(13);"(If you have already calculated rank sums,": PRINT TAB(15);"press ENTER to skip directly to RANK TESTS.)"
42  LOCATE AP,66: INPUT "",FILE$
43  IF FILE$="" THEN DIM C(100),CF(100): PRINT: GOTO 110
50  OPEN FILE$ FOR INPUT AS #1: INPUT #1, A,C
60  DIM D(A,C),CS(A,C+5),SR(3,C*2+1),N$(A),X(A),X2(A),T(A),SD(A),MD(A),C(C),CF(C)
70  FOR T=1 TO A: INPUT #1, T(T): NEXT
80  FOR T=1 TO A: FOR Z=1 TO C: INPUT #1, D(T,Z): NEXT: NEXT
90  FOR T=1 TO A: FOR Z=1 TO T(T): INPUT #1, CS(T,Z): NEXT: NEXT
100  FOR T=1 TO A: INPUT #1, N$(T),X(T),X2(T),MD(T),SD(T): NEXT: CLOSE #1
110  PRINT :PRINT :PRINT
120  PRINT TAB(15);"1.)  WILCOXON RANK SUM TEST (independent samples)": PRINT
125  PRINT TAB(15);"2.)  SIGNED RANK TEST   (paired samples)": PRINT
130  PRINT TAB(15);"3.)  RANK CORRELATION COEFFICIENT": PRINT :PRINT
140  PRINT TAB(20);:INPUT "Select the RANK test you want:     ",ASUB
142  IF ABS(ASUB-2)>1.01 THEN BEEP: GOTO 140
145  CLS: ON ASUB GOTO 200,620,950
150  PRINT: PRINT TAB(5);"What are the SAMPLE NUMBERS of the 2 groups you want to compare?": PRINT: PRINT TAB(10);
155  PRINT TAB(10);: INPUT;"Number:  ",NS1: IF NS1<=A THEN PRINT " `";N$(NS1);"'"; ELSE GOSUB 165: GOTO 155
160  PRINT TAB(46);: INPUT;"Number:  ",NS2: IF NS2<=A THEN PRINT " `";N$(NS2);"'": GOTO 170 ELSE GOSUB 165: GOTO 160
165  BEEP: PRINT TAB(20);FILE$;" has only";A;"samples.": RETURN
170  IF ASUB<3 THEN PRINT "Medians = ";TAB(17);MD(NS1);TAB(53);MD(NS2)
172  IF ASUB<2 OR T(NS1)=T(NS2) THEN 180 ELSE PRINT: PRINT "These 2 samples do not have the same number of elements----": PRINT TAB(25);"a rank correlation coefficient cannot be calculated."
173  PRINT: PRINT TAB(20);"Press any key to return to menu:"
175  A$=INKEY$: IF A$="" THEN 175 ELSE 110
180  PRINT: PRINT: RETURN
200  PRINT TAB(18);"WILCOXON RANK SUM TEST (two-tailed)": PRINT TAB(18);STRING$(35,205)
201  IF FILE$<>"" THEN GOSUB 150: N=T(NS1)+T(NS2): GOTO 210
202  PRINT :PRINT :PRINT TAB(10);
203  INPUT "Enter the NUMBER of observations in Sample #1:  ",N1
204  PRINT TAB(10);:INPUT "Enter the NUMBER of observations in Sample #2:  ",N2
205  PRINT: N=N1+N2: NMN=1: IF N1>N2 THEN NMN=2: N3=N2: N2=N1: N1=N3
206  PRINT TAB(12);"Enter the SUM of the ranks for Sample #";NMN;:INPUT ":  ",T
207  ERASE C,CF: DIM C(N1),CF(N1): GOTO 370
210  T1=1: T2=1
220  PRINT: AP=CSRLIN: COLOR 23: PRINT TAB(26);"RANKING SAMPLES": COLOR 7
230  FOR Z=1 TO N: V1=VAL(D(NS1,CS(NS1,T1))): V2=VAL(D(NS2,CS(NS2,T2)))
235  IF T1>T(NS1) THEN SR(1,Z)=V2: SR(2,Z)=0: T2=T2+1: GOTO 260
240  IF T2>T(NS2) THEN SR(1,Z)=V1: SR(2,Z)=1: T1=T1+1: GOTO 260
245  IF V1<V2 THEN SR(1,Z)=V1: SR(2,Z)=1: T1=T1+1: GOTO 260
250  SR(1,Z)=V2: SR(2,Z)=0: T2=T2+1
260  NEXT: AD=1: SZ=1
270  FOR Z=1 TO N
280  IF SR(1,Z)=SR(1,Z+1) THEN AD=AD+1: SZ=SZ+Z+1: GOTO 300
290  FOR T=Z TO (Z+1-AD) STEP -1: SR(3,T)=SZ/AD: NEXT T: SZ=Z+1: AD=1
300  NEXT Z: SR1=0: SR2=0
310  FOR Z=1 TO N
320  IF SR(2,Z)=1 THEN SR1=SR1+SR(3,Z) ELSE SR2=SR2+SR(3,Z)
330  NEXT
340  LOCATE AP,18: PRINT "Sum of ranks for SAMPLE ";NS1;" = ";SR1: PRINT
350  PRINT TAB(18);"Sum of ranks for SAMPLE ";NS2;" = ";SR2: PRINT
360  IF T(NS1)<=T(NS2) THEN N1=T(NS1): N2=T(NS2): T=SR1 ELSE N1=T(NS2): N2=T(NS1): T=SR2
370  XN=N1*(N+1): IF XN-T<T THEN T=XN-T
380  AK=0: IF N>30 AND T>XN-1.96*SQR(N1*N2*(N+1)/12) THEN AK=1: AP=CSRLIN: AP=AP+3: GOTO 600
390  T=T-N1*(N1+1)*0.5
400  PRINT:PRINT: AP=CSRLIN: COLOR 23: PRINT TAB(22);"CALCULATING PROBABILITY"
410  BF=4: WT=0: FT=0: CB=0: CBF=0
420  FOR Z=1 TO N1: C(Z)=0: CF(Z)=0: NEXT
430  IF N1<4 THEN 512
440  IF T-CBF<=N2-CB THEN CT=T-CBF+1: CK=0: GOTO 475
450  CX=N2-CB+1: CD=T-CBF-CX+1: CDD=CX-CD: CK=INT(CD*0.5+0.5)
452  IF CD<=CX THEN 458
453  CDD=0: CDK=CD: CD=CX: IF CK>CX THEN CK=CX
454  FOR Z=1 TO CK: WT=WT+CD*0.5*(CX+CDD+1)+INT((CDD*(CDD+2)+1)*0.25)
455  CX=CX-1: CDK=CDK-2: IF CDK>=CX THEN CD=CX ELSE CD=CDK
456  CDD=CX-CD
457  NEXT Z: GOTO 470
458  FOR Z=1 TO CK: WT=WT+CD*0.5*(CX+CDD+1)+INT((CDD*(CDD+2)+1)*0.25)
460  CX=CX-1: CD=CD-2: CDD=CDD+1
465  NEXT Z
470  CT=T+1-CBF-3*CK
475  FOR Z=1 TO INT(CT/3+0.7): WT=WT+INT((CT*(CT+2)+1)*0.25): CT=CT-3: NEXT Z
480  CBF=CBF+4
490  IF CBF>T THEN BF=BF+1: IF BF>N1 THEN 530 ELSE CF(BF)=CF(BF)+BF: CBF=CF(BF): GOTO 490
500  C(BF)=C(BF)+1
510  FOR Z=2 TO BF: C(Z)=C(BF): CF(Z)=CBF: NEXT Z: BF=4: CB=C(4): CBF=CF(4): GOTO 440
512  BF=N1-1: CT=T-CF(BF)+1: CX=N2-C(BF)+1
514  IF CT<=CX THEN WT=WT+CT ELSE WT=WT+CX
516  CF(BF)=CF(BF)+N1+1-BF
518  IF CF(BF)>T OR C(BF)>=N2 THEN BF=BF-1: IF BF<1 THEN 530 ELSE CF(BF)=CF(BF)+ N1+1-BF: GOTO 518
520  C(BF)=C(BF)+1
525  FOR Z=BF+1 TO 2: C(Z)=C(BF): CF(Z)=CF(BF): NEXT Z: GOTO 512
530  FT=N: FOR Z=N1 TO 2 STEP -1: N=N-1: FT=FT*N/Z: IF FT>1E+35 THEN 560
550  NEXT Z: P=WT*2/FT: GOTO 600
560  FT=LOG(FT): FOR Z=Z-1 TO 2 STEP -1: N=N-1: FT=FT+LOG(N/Z): NEXT Z
570  FOR Z=Z-1 TO 2 STEP -1: N=N-1: FT=FT+LOG(N/Z): NEXT Z
580  P=EXP(LOG(2*WT)-FT)
600  PLAY "MB ML T150 L32 N56N44N56N44N56N44N54N42N54N42N54N42N53N41N53N41N51N39N51N39N51N39N49N37N49N37N49N37N49N37N49N37N49N37 "
610  COLOR 0,7: LOCATE AP,1: PRINT TAB(26); "P = ";: IF AK=1 THEN PRINT "> .05"; ELSE IF P<1E-08 THEN PRINT  "< 10 (-8)"; ELSE PRINT P;
615  PRINT TAB(75): COLOR 7,0: GOTO 1050
620  PRINT TAB(22);"SIGNED RANK TEST (two-tailed)":PRINT TAB(22);STRING$(29,205)
621  IF FILE$<>"" THEN GOSUB 150: GOTO 640
622  PRINT: PRINT TAB(10);:INPUT "Enter the NUMBER of observations in each sample group:  ",N
623  ERASE C,CF: DIM C(N),CF(N)
624  PRINT: PRINT TAB(15);:INPUT "Enter the SUM of negative signed ranks:  ",NN
625  PRINT TAB(15);:INPUT "Enter the SUM of positive signed ranks:  ",NP
626  IF ABS(NN)<=NP THEN T=ABS(NN) ELSE T=NP
627  IF ABS(NN)+NP<>N*(N+1)*0.5 THEN BEEP: PRINT "The SUM of the absolute values of positive and negative ranks should = ";N*(N+1)*0.5
630  GOTO 800
640  PRINT: AP=CSRLIN: COLOR 23: PRINT TAB(26);"RANKING SAMPLES": COLOR 7
650  N=T(NS1): CR=0
660  FOR Z=1 TO N: V1=VAL(D(NS1,Z)): V2=VAL(D(NS2,Z)): VD=V1-V2
670  IF ABS(VD)<0 THEN 710
680  CR=CR+1: AY=CR
690  FOR TZ=1 TO CR-1:IF ABS(VD)<ABS(SR(1,TZ)) THEN SR(1,AY)=SR(1,AY-1):AY=AY-1
700  NEXT TZ: SR(1,AY)=VD
710  NEXT Z: AD=1: SZ=1
720  FOR Z=1 TO CR: IF ABS(SR(1,Z))=ABS(SR(1,Z+1)) THEN AD=AD+1: SZ=SZ+Z+1:  GOTO 750
730  FOR T=(Z+1-AD) TO Z: SR(2,T)=SZ/AD: IF SR(1,T)>0 THEN SR(3,T)=1
740  NEXT T: SZ=Z+1: AD=1
750  NEXT Z: SNP=0: SNN=0
760  FOR Z=1 TO CR: IF SR(3,Z)=1 THEN SNP=SNP+SR(2,Z) ELSE SNN=SNN+SR(2,Z)
770  NEXT Z
780  LOCATE AP,15: PRINT "The sum of positive signed RANKS is: ";SNP: PRINT
790  PRINT TAB(15);"The sum of negative signed RANKS is: ";SNN: PRINT
795  T=SNN: IF SNN>SNP THEN T=SNP
800  PRINT:PRINT:AP=CSRLIN: COLOR 23: PRINT TAB(24);"CALCULATING PROBABILITY"
805  IF N<5 THEN P=1: GOTO 942
810  WT=N+1: IF WT>T+1 THEN WT=T+1
815  IF T<=N THEN CT=T-2: GOTO 850
820  CX=N-1: CD=T-CX-2: CDD=CX-CD: CK=INT(CD*0.5+0.5)
825  CDK=CD: IF CD>CX THEN CDD=0: CD=CX: IF CK>CX THEN CK=CX
830  FOR Z=1 TO CK: WT=WT+CD*0.5*(CX+CDD+1)+INT((CDD*(CDD+2)+1)*0.25)
835  CX=CX-1: CDK=CDK-2: IF CDK<CX THEN CD=CDK ELSE CD=CX
840  CDD=CX-CD: NEXT Z
845  CT=T-3*CK-2
850  FOR Z=1 TO INT(CT/3+0.7): WT=WT+INT((CT*(CT+2)+1)*0.25): CT=CT-3: NEXT Z
855  AS=0: FOR Z=1 TO N: C(Z)=Z-1: CF(Z)=AS: AS=AS+Z: NEXT Z
860  C(4)=4: CB=4: CBF=10: BF=4
865  IF T-CBF<=N-CB THEN CT=T-CBF+1: GOTO 915
870  CX=N-CB+1: CD=T-CBF-CX+1: CDD=CX-CD: CK=INT(CD*0.5+0.5)
875  IF CD<=CX THEN 900
880  CDD=0: CDK=CD: CD=CX: IF CK>CX THEN CK=CX
885  FOR Z=1 TO CK: WT=WT+CD*0.5*(CX+CDD+1)+INT((CDD*(CDD+2)+1)*0.25)
890  CX=CX-1: CDK=CDK-2: IF CDK<CX THEN CD=CDK ELSE CD=CX
895  CDD=CX-CD: NEXT Z: GOTO 910
900  FOR Z=1 TO CK: WT=WT+CD*0.5*(CX+CDD+1)+INT((CDD*(CDD+2)+1)*0.25)
905  CX=CX-1: CD=CD-2: CDD=CDD+1: NEXT Z
910  CT=T+1-CBF-3*CK
915  FOR Z=1 TO INT(CT/3+0.7): WT=WT+INT((CT*(CT+2)+1)*0.25): CT=CT-3: NEXT Z
920  CBF=CBF+4
925  IF CBF>T THEN BF=BF+1: IF BF>N THEN 940 ELSE CF(BF)=CF(BF)+BF: CBF=CF(BF):   FOR Z=4 TO BF-1: C(Z)=C(BF)+1: CF(Z)=CBF: NEXT Z: GOTO 925
930  C(BF)=C(BF)+1
935  CB=C(BF): BF=4: GOTO 865
940  IF N<100 THEN P=WT/2^(N-1) ELSE P=EXP(LOG(WT)-(N-1)*LOG(2))
942  PLAY "MB O3 T100 L10 CL24D#L10EL32 GF# L10 G. L32 ED L16 E L30 GE L5 C"
945  LOCATE AP,1: COLOR 0,7: PRINT TAB(26);"P =  ";: IF P>0.5 THEN PRINT "> .5"; ELSE IF P<1E-08 THEN PRINT "< 10 (-8)"; ELSE PRINT P;
948  PRINT TAB(75);: COLOR 7,0: GOTO 1050
950  PRINT TAB(23);"SPEARMAN'S RANK CORRELATION ": PRINT TAB(23);STRING$(27,205)
955  GOSUB 150
960  N=T(NS1): CD=0: S2=0
965  FOR Z=1 TO N
970  FOR T=1 TO N: IF CS(NS1,Z)=CS(NS2,T) THEN CD=Z-T: S2=S2+CD*CD
975  NEXT T: NEXT Z
980  SR=1-(6*S2/(N*(N*N-1)))
990  PLAY "MB MS O3 L11 CCC O2 L2 C": PRINT : PRINT TAB(10);: COLOR 0,7
1000  PRINT TAB(15); "Correlation coefficient = ";SR;TAB(65): COLOR 7,0
1010  PRINT :PRINT :PRINT "The probability that a given value of Spearman's correlation coefficient is": PRINT "  significantly different that 0 can be evaluated by reference to tables."
1050  PRINT :PRINT :PRINT: PRINT TAB(7);
1060  PRINT "Do you want to perform another rank test ";
1070  IF FILE$="" THEN PRINT "? (Y or N)  ";ELSE PRINT "using this datafile?  ";
1080  INPUT "",A$
1090  IF A$="Y" OR A$="y" THEN CLS: GOTO 110
1100  END
1110  BEEP: PRINT: IF ERL=50 AND ERR=53 THEN PRINT: PRINT TAB(13); "I cannot find a file by that name on drive "; ELSE 1150
1120  IF MID$(FILE$,2,1)=":" THEN DR$=LEFT$(FILE$,2) ELSE DR$="A:"
1130  PRINT DR$: PRINT "Your files are:": FILES DR$+"*.*": RESUME 30
1150  ON ERROR GOTO 0
